/*
 * CalendarDisplay.java
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import java.text.DateFormat;

public class CalendarDisplay extends JFrame 
{
	
	 static JTextField dateTextField = new JTextField();
	 static JTextField timeTextField = new JTextField();
	 static Timer myTimer;

  public static void main(String args[]) 
  {
  	// construct frame
    new CalendarDisplay().show();
    // start timer
    myTimer.start();
  }

  public CalendarDisplay() 
  {
  	// frame constructor
  	setTitle("Calendar");
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
   	getContentPane().setLayout(new GridBagLayout());


    // add text fields
  	GridBagConstraints gridConstraints = new GridBagConstraints();
    dateTextField.setText("");
    dateTextField.setColumns(20);
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    getContentPane().add(dateTextField, gridConstraints);
    
    timeTextField.setText("");
    timeTextField.setColumns(20);
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(timeTextField, gridConstraints);
    
    pack();
    
    // create timer
    myTimer = new Timer(1000, new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		myTimerActionPerformed(e);
    	}
    });
  }
  
	private void myTimerActionPerformed(ActionEvent e)
	{
		// display date and time
		Date today = new Date();
		dateTextField.setText(DateFormat.getDateInstance(DateFormat.FULL).format(today));
		timeTextField.setText(DateFormat.getTimeInstance().format(today));
	}
  private void exitForm(WindowEvent e) 
  {
    System.exit(0);
  }
}
