/*
 * Savings.java
 * KIDware (206) 721-2556
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;

public class Savings extends JFrame 
{
	
	static JLabel depositLabel = new JLabel();
	static JLabel interestLabel = new JLabel();
	static JLabel monthsLabel = new JLabel();
	static JLabel finalLabel = new JLabel();
	static JTextField depositTextField = new JTextField();
	static JTextField interestTextField = new JTextField();
	static JTextField monthsTextField = new JTextField();
	static JTextField finalTextField = new JTextField();
	static JButton calculateButton = new JButton();
	static JButton exitButton = new JButton();

  public static void main(String args[]) 
  {
  	//construct frame
    new Savings().show();
  }

  public Savings() 
  {
  	// code to build the form
    setTitle("Savings Account");
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
		// position controls (establish event methods)
    GridBagConstraints gridConstraints = new GridBagConstraints();
    depositLabel.setText("Monthly Deposit");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    getContentPane().add(depositLabel, gridConstraints);
    interestLabel.setText("Yearly Interest");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(interestLabel, gridConstraints);
    monthsLabel.setText("Number of Months");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    getContentPane().add(monthsLabel, gridConstraints);
    finalLabel.setText("Final Balance");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 3;
    getContentPane().add(finalLabel, gridConstraints);

    depositTextField.setText("");
    depositTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 0;
    getContentPane().add(depositTextField, gridConstraints);
    depositTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		depositTextFieldActionPerformed(e);
    	}
    });

    interestTextField.setText("");
    interestTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 1;
    getContentPane().add(interestTextField, gridConstraints);
    interestTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		interestTextFieldActionPerformed(e);
    	}
    });

    monthsTextField.setText("");
    monthsTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 2;
    getContentPane().add(monthsTextField, gridConstraints);
    monthsTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		monthsTextFieldActionPerformed(e);
    	}
    });

    finalTextField.setText("");
    finalTextField.setFocusable(false);
    finalTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 3;
    getContentPane().add(finalTextField, gridConstraints);
    
    calculateButton.setText("Calculate");
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 4;
    getContentPane().add(calculateButton, gridConstraints);
    calculateButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		calculateButtonActionPerformed(e);
    	}
    });
    exitButton.setText("Exit");
    exitButton.setFocusable(false);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 5;
    getContentPane().add(exitButton, gridConstraints);
    exitButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		exitButtonActionPerformed(e);
    	}
    });
    pack();
	}
	
	private void depositTextFieldActionPerformed(ActionEvent e)
	{
		depositTextField.transferFocus();
	}
	
	private void interestTextFieldActionPerformed(ActionEvent e)
	{
		interestTextField.transferFocus();
	}
	
	private void monthsTextFieldActionPerformed(ActionEvent e)
	{
		monthsTextField.transferFocus();
	}
	
	private void calculateButtonActionPerformed(ActionEvent e)
	{
		double deposit;
		double interest;
		double months;
		double finalBalance;
		double monthlyInterest;
		// make sure each is a valid number
		if (!validateDecimalNumber(monthsTextField) || !validateDecimalNumber(interestTextField) || !validateDecimalNumber(depositTextField))
		{
			// if one or more fields not valid number, then exit method
			return;
		}
    // read values from text fields
    deposit = Double.valueOf(depositTextField.getText()).doubleValue();
    interest = Double.valueOf(interestTextField.getText()).doubleValue();
    monthlyInterest = interest / 1200;
    months = Double.valueOf(monthsTextField.getText()).doubleValue();
    // compute final value and put in text field;
    if (interest == 0)
    { 
      finalBalance = deposit * months;
    }
    else
    {
    	finalBalance = deposit * (Math.pow((1 + monthlyInterest), months) - 1) / monthlyInterest;
    }
    finalTextField.setText(new DecimalFormat("0.00").format(finalBalance));
	}

		
	private void exitButtonActionPerformed(ActionEvent e)
	{
  	System.exit(0);
	}
	
  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }
	
	public boolean validateDecimalNumber(JTextField tf)
	{
		// checks to see if text field contains
		// valid decimal number with only digits and a single decimal point
		String s = tf.getText().trim();
		boolean hasDecimal = false;
		boolean valid = true;
		if (s.length() == 0)
		{
			valid = false;
		}
		else
		{
			for (int i = 0; i < s.length(); i++)
			{
				char c = s.charAt(i);
				if (c >= '0' && c <= '9')
				{
					continue;
				}
				else if (c == '.' && !hasDecimal)
				{
					hasDecimal = true;
				}
				else
				{
					// invalid character found
					valid = false;
				}
			}
		}
		if (valid)
		{
			tf.setText(s);
		}
		else
		{
			tf.setText("");
			tf.requestFocus();
		}
		return (valid);
	}
}
