/*
 * Customer.java
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Customer extends JFrame 
{
  
  static JLabel nameLabel = new JLabel();
  static JTextField nameTextField = new JTextField();
  static JLabel ageLabel = new JLabel();
  static JTextField ageTextField = new JTextField();
  static JPanel sexPanel = new JPanel();
  static ButtonGroup sexButtonGroup = new ButtonGroup();
  static JRadioButton maleRadioButton = new JRadioButton();
  static JRadioButton femaleRadioButton = new JRadioButton();
  static JPanel activityPanel = new JPanel();
  static JCheckBox runCheckBox = new JCheckBox();
  static JCheckBox walkCheckBox = new JCheckBox();
  static JCheckBox bikeCheckBox = new JCheckBox();
  static JCheckBox swimCheckBox = new JCheckBox();
  static JCheckBox skiCheckBox = new JCheckBox();
  static JCheckBox skateCheckBox = new JCheckBox();
  static JPanel cityPanel = new JPanel();
  static JComboBox cityComboBox = new JComboBox();
  static JPanel levelPanel = new JPanel();
  static ButtonGroup levelButtonGroup = new ButtonGroup();
  static JRadioButton extremeRadioButton = new JRadioButton();
  static JRadioButton advancedRadioButton = new JRadioButton();
  static JRadioButton intermediateRadioButton = new JRadioButton();
  static JRadioButton beginnerRadioButton = new JRadioButton();
  static JButton showButton = new JButton();
  static JButton newButton = new JButton();
  static JButton exitButton = new JButton();
  static String athleticLevel;
  static JCheckBox[] activity = new JCheckBox[6];

  public static void main(String args[]) 
  {
  	// construct frame
    new Customer().show();
    
    // Load combo box with potential city names
    cityComboBox.addItem("Seattle");
    cityComboBox.addItem("Bellevue");
    cityComboBox.addItem("Kirkland");
    cityComboBox.addItem("Everett");
    cityComboBox.addItem("Mercer Island");
    cityComboBox.addItem("Renton");
    cityComboBox.addItem("Issaquah");
    cityComboBox.addItem("Kent");
    cityComboBox.addItem("Bothell");
    cityComboBox.addItem("Tukwila");
    cityComboBox.addItem("West Seattle");
    cityComboBox.addItem("Edmonds");
    cityComboBox.addItem("Tacoma");
    cityComboBox.addItem("Federal Way");
    cityComboBox.addItem("Burien");
    cityComboBox.addItem("SeaTac");
    cityComboBox.addItem("Woodinville");
    cityComboBox.setSelectedIndex(0);
    // check box array
    activity[0] = runCheckBox;
    activity[1] = walkCheckBox;
    activity[2] = bikeCheckBox;
    activity[3] = swimCheckBox;
    activity[4] = skiCheckBox;
    activity[5] = skateCheckBox;

    maleRadioButton.doClick();
    intermediateRadioButton.doClick();
  }
  
  public Customer() 
  {
  	// create frame
  	setTitle("Customer Profile");
  	setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
        exitForm(e);
      }
    });
   	getContentPane().setLayout(new GridBagLayout());
   	
   	// position controls
   	GridBagConstraints gridConstraints;
		nameLabel.setText("Name");
		gridConstraints = new GridBagConstraints();
		gridConstraints.insets = new Insets(10, 0, 0, 0);
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 0;
		getContentPane().add(nameLabel, gridConstraints);
		nameTextField.setText("");
    nameTextField.setColumns(20);
		gridConstraints = new GridBagConstraints();
		gridConstraints.insets = new Insets(10, 0, 0, 0);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    getContentPane().add(nameTextField, gridConstraints);
		
		ageLabel.setText("Age");
		gridConstraints = new GridBagConstraints();
		gridConstraints.insets = new Insets(10, 10, 0, 0);
		gridConstraints.gridx = 2;
		gridConstraints.gridy = 0;
		getContentPane().add(ageLabel, gridConstraints);
		ageTextField.setText("");
    ageTextField.setColumns(5);
		gridConstraints = new GridBagConstraints();
		gridConstraints.insets = new Insets(10, 0, 0, 0);
    gridConstraints.gridx = 3;
    gridConstraints.gridy = 0;
    getContentPane().add(ageTextField, gridConstraints);

    sexPanel.setLayout(new GridBagLayout());
		sexPanel.setBorder(BorderFactory.createTitledBorder("Sex"));
    maleRadioButton.setText("Male");
		sexButtonGroup.add(maleRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 0;
		gridConstraints.anchor = GridBagConstraints.WEST;
		sexPanel.add(maleRadioButton, gridConstraints);
    femaleRadioButton.setText("Female");
		sexButtonGroup.add(femaleRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 1;
		gridConstraints.anchor = GridBagConstraints.WEST;
		sexPanel.add(femaleRadioButton, gridConstraints);
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(sexPanel, gridConstraints);

    activityPanel.setLayout(new GridBagLayout());
		activityPanel.setBorder(BorderFactory.createTitledBorder("Activities"));
    runCheckBox.setText("Running");
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 0;
		gridConstraints.anchor = GridBagConstraints.WEST;
		activityPanel.add(runCheckBox, gridConstraints);
    walkCheckBox.setText("Walking");
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 1;
		gridConstraints.anchor = GridBagConstraints.WEST;
		activityPanel.add(walkCheckBox, gridConstraints);
    bikeCheckBox.setText("Biking");
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 2;
		gridConstraints.anchor = GridBagConstraints.WEST;
		activityPanel.add(bikeCheckBox, gridConstraints);
    swimCheckBox.setText("Swimming");
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 3;
		gridConstraints.anchor = GridBagConstraints.WEST;
		activityPanel.add(swimCheckBox, gridConstraints);
    skiCheckBox.setText("Skiing");
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 4;
		gridConstraints.anchor = GridBagConstraints.WEST;
		activityPanel.add(skiCheckBox, gridConstraints);
    skateCheckBox.setText("Skating");
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 5;
		gridConstraints.anchor = GridBagConstraints.WEST;
		activityPanel.add(skateCheckBox, gridConstraints);
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    getContentPane().add(activityPanel, gridConstraints);

    cityPanel.setLayout(new GridBagLayout());
		cityPanel.setBorder(BorderFactory.createTitledBorder("Cities"));
    cityComboBox.setEditable(true);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    cityPanel.add(cityComboBox, gridConstraints);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    getContentPane().add(cityPanel, gridConstraints);

    levelPanel.setLayout(new GridBagLayout());
		levelPanel.setBorder(BorderFactory.createTitledBorder("Athletic Level"));
    extremeRadioButton.setText("Extreme");
		levelButtonGroup.add(extremeRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 0;
		gridConstraints.anchor = GridBagConstraints.WEST;
		levelPanel.add(extremeRadioButton, gridConstraints);
		extremeRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		levelRadioButtonActionPerformed(e);
  		}
		});
    advancedRadioButton.setText("Advanced");
		levelButtonGroup.add(advancedRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 1;
		gridConstraints.anchor = GridBagConstraints.WEST;
		levelPanel.add(advancedRadioButton, gridConstraints);
		advancedRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		levelRadioButtonActionPerformed(e);
  		}
		});
    intermediateRadioButton.setText("Intermediate");
		levelButtonGroup.add(intermediateRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 2;
		gridConstraints.anchor = GridBagConstraints.WEST;
		levelPanel.add(intermediateRadioButton, gridConstraints);
		intermediateRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		levelRadioButtonActionPerformed(e);
  		}
		});
    beginnerRadioButton.setText("Beginner");
		levelButtonGroup.add(beginnerRadioButton);
		gridConstraints = new GridBagConstraints();
		gridConstraints.gridx = 0;
		gridConstraints.gridy = 3;
		gridConstraints.anchor = GridBagConstraints.WEST;
		levelPanel.add(beginnerRadioButton, gridConstraints);
		beginnerRadioButton.addActionListener(new ActionListener()
		{
  		public void actionPerformed(ActionEvent e) 
  		{
    		levelRadioButtonActionPerformed(e);
  		}
		});
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 2;
    getContentPane().add(levelPanel, gridConstraints);
    
    showButton.setText("Show Profile");
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 3;
    gridConstraints.gridy = 1;
    getContentPane().add(showButton, gridConstraints);
    showButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		showButtonActionPerformed(e);
    	}
    });
    newButton.setText("New Profile");
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 3;
    gridConstraints.gridy = 2;
		gridConstraints.anchor = GridBagConstraints.NORTH;
    getContentPane().add(newButton, gridConstraints);
    newButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		newButtonActionPerformed(e);
    	}
    });
    exitButton.setText("Exit");
		gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 3;
    gridConstraints.gridy = 3;
    getContentPane().add(exitButton, gridConstraints);
    exitButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		exitButtonActionPerformed(e);
    	}
    });


    pack();
  	Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());
 
  }
	

	private void levelRadioButtonActionPerformed(ActionEvent e)
  {
  	athleticLevel = e.getActionCommand();
  }

	private void showButtonActionPerformed(ActionEvent e)
  {
  	String msg, pronoun;
    String actMsg;
    // Check to make sure name entered
    if (nameTextField.getText().equals(""))
    {
    	JOptionPane.showConfirmDialog(null, "The profile requires a name.", "No Name Entered", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
      nameTextField.requestFocus();
      return;
  	}
		// Check to make sure age entered
    if (nameTextField.getText().equals(""))
    {
    	JOptionPane.showConfirmDialog(null, "The profile requires an age.", "No Age Entered", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
      nameTextField.requestFocus();
      return;
  	}
  	// Put together customer profile message
    msg = nameTextField.getText() + " is " + ageTextField.getText() + " years old.\n";
    if (maleRadioButton.isSelected())
    {
    	pronoun = "He ";
    }
    else
    {
    	pronoun = "She ";
    }
    msg += pronoun + "lives in " + cityComboBox.getSelectedItem() + ".\n";
    msg += pronoun + "is a";
    if (!beginnerRadioButton.isSelected())
    {
   		msg += "n ";
   	}
   	else
   	{
	    msg += " ";
	  }
    msg += athleticLevel.toLowerCase() + " level athlete.\n";
    actMsg = "";
    // add activities (if any)
    for (int i = 0; i < 6; i++)
    {
			if (activity[i].isSelected())
			{
  	   	actMsg += "     " + activity[i].getText() + "\n";
  	  }
		}
    if (!actMsg.equals(""))
    {
	  	msg += "Activities include:\n" + actMsg;
	  }
	  else
	  {
      msg += "\n";
  	}
   	JOptionPane.showConfirmDialog(null, msg, "Customer Profile", JOptionPane.DEFAULT_OPTION, JOptionPane.PLAIN_MESSAGE);
  }
	private void newButtonActionPerformed(ActionEvent e)
  {
		// Blank out name and reset check boxes
    nameTextField.setText("");
    ageTextField.setText("");
    runCheckBox.setSelected(false);
    walkCheckBox.setSelected(false);
    bikeCheckBox.setSelected(false);
    swimCheckBox.setSelected(false);
    skiCheckBox.setSelected(false);
    skateCheckBox.setSelected(false);
    nameTextField.requestFocus();

  }
	
	private void exitButtonActionPerformed(ActionEvent e)
  {
  	  	System.exit(0);
  }

  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }
}
